﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.801
@EndOfDesignText@
Sub Class_Globals
	Type Mypkt(x As Float,y As Float,isError As Boolean)
	Dim xui As XUI
	Dim bmEF As BitmapCreatorEffects
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	bmEF.Initialize
End Sub

public Sub drawGrindEdge(picWidth As Float,picHeight As Float, grindAngle As Float, _
	doAdjust As Int, rotAngle As Float, _
	flipHoriz As Boolean, flipVertical As Boolean, highlightBevelUpper As Boolean, _
	highlightBevelLower As Boolean,showHelpLines As Boolean, onebevel As Boolean) As B4XBitmap
	'rotAngle: 0: schleifkante ist links, messer waagrecht
	'das messer wird erstmal waagrecht gezeichnet
	'doAdjust: die Messerdicke wird so angepasst, dass der Schliff voll zu sehen ist:
	'0 keine Anpassung, 1 Anpassung an doppelten schliff, 2 Anpassung an onebevel angepasst
	'die kombi Onebevel=true und 1 ist nicht sinnvoll.
	'flipHoriz ist von links nach rechts, Vertical von oben nach unten
	Dim canv As B4XCanvas
	Dim panW,panH As Int
	Dim x0,y0,HalbeDicke, GrindLen=0,rr As Float
	Dim pkt (5) As Mypkt		'index 0 wird nicht verwendet
	Dim pRight(2),Px0y0 As Mypkt	'pTop(2),
	Dim dickenPlus As Int=2
	Dim PenWid As Int=2
	
	'Dim baseRect As B4XRect
	'Dim bc As BitmapCreator
	
	
	If picHeight=0 And picWidth=0 Then
		picHeight=300
		picWidth=900
	End If
	Dim xview As B4XView = xui.CreatePanel("")
	xview.SetLayoutAnimated(0, 0, 0, picWidth, picHeight)
	'xview.Color=Colors.Yellow		'setzt die Hintergrundfarbe für das zurückgegebene BMP
	panW=xview.Width
	panH=xview.Height
	x0=panW*0.05
	
	If onebevel Then
		y0=panH/6
	Else
		y0=panH/2
	End If
	
	HalbeDicke=panH/3
	If grindAngle>0 And grindAngle<90 And doAdjust>0 Then
		If doAdjust=1 Then	'auf doppelt anpassen
			If HalbeDicke/TanD(grindAngle)> panW-x0 Then
				'Log ("adjust ist 1: " & (HalbeDicke/TanD(grindAngle)) & "  //  " & (panW-x0))
				'anpassen:
				HalbeDicke=(panW-x0)*SinD(grindAngle)
			End If
		Else	'doadjust = 2
			If 2*HalbeDicke/TanD(grindAngle)> panW-x0 Then
				'Log ("adjust ist 2: " &(2*HalbeDicke/TanD(grindAngle)) & "  //  " & (panW-x0))
				HalbeDicke=0.5*(panW-x0)*SinD(grindAngle)
			End If
		End If
	End If
	
	'canv.DrawRect(canv.TargetRect,panbackCL,True,1)	'alternative
	'Graue basis:
'	baseRect.Initialize(0,y0+PenWid/2,panW,panH)
'	canv.DrawLine(0dip,y0+PenWid,panW,y0+PenWid,0x50000000,PenWid)
'	canv.DrawRect(baseRect,0x50000000,True,PenWid)

	Px0y0.x=x0	:Px0y0.y=y0		'brauch ich unten für die Geraden-Berechnungen
	'pkt(0).x=0 : pkt(0).y=0	'wird nicht verwendet
	
	'es geht im Uhrzeigersinn von Pkt(0) bis Pkt(4)	'!!HIer noch alle Punkte relativ zur Spitze!!!!!!
	Select Case grindAngle
		Case 0
			'nothing
		Case 90
			If onebevel Then
				pkt(1).x=0	: pkt(1).y=0        'weil unten y0 und x0 dazu gezählt wird
				pkt(4).x=0	:pkt(4).y=2*HalbeDicke	'weil unten y0 dazu gezählt wird
			Else
				pkt(1).y=-HalbeDicke	:pkt(1).x=0
				pkt(4).y=HalbeDicke		:pkt(4).x=0
			End If
		Case Else
			If onebevel Then	'einfach angeschliffen.
				GrindLen=2*HalbeDicke/SinD(grindAngle)
				'pkt(1).x=Sqrt(Power(GrindLen,2)-Power(2*HalbeDicke,2))
				'oder:
				pkt(1).x=GrindLen*CosD(grindAngle)
				'Log(GrindLen & ", " & CosD(grindAngle)&  ", " & pkt(1).x)
				pkt(1).y=0
				pkt(4).x=pkt(1).x
				pkt(4).y=2*HalbeDicke
			Else	'doppelt angeschliffen
				GrindLen=HalbeDicke/SinD(grindAngle)
				pkt(1).x=GrindLen*CosD(grindAngle)
				pkt(1).y=-GrindLen*SinD(grindAngle)
				pkt(4).x=pkt(1).x
				pkt(4).y=-pkt(1).y
			End If
	End Select
	
	'für die korrekten Schnittpunkte mit den außenkanten müssen wir schon hier x0 und y0 dazu zählen
	For ii=1 To 4 Step 3
		pkt(ii).x=x0+pkt(ii).x
		pkt(ii).y=y0+pkt(ii).y
		'Log(ii & ", " & pkt(ii).x & ", " & pkt(ii).y)
	Next
	'dadurch werden Pkt 2 und 3 hier gleich richtig gerechnet
	pRight(0).x=panW	:pRight(0).y=0
	pRight(1).x=panW	:pRight(1).y=panH
	
	Select Case True
		Case grindAngle=0
			'nothing
		Case Else
			pkt(2)=Geradenschnittpunkt2(pkt(1),dickenPlus,pRight(0),pRight(1))
			pkt(3)=Geradenschnittpunkt2(pkt(4),-dickenPlus,pRight(0),pRight(1))
	End Select
	
	
	If grindAngle>0 Then
		Dim gpx As B4XPath
		gpx.Initialize(x0,y0)
		'Log("***********************")
		'Log ("0, "&x0 & ", " & y0)
		For ii=1 To 4
			gpx.LineTo(pkt(ii).x,pkt(ii).y)
			'Log(ii & ", " & pkt(ii).x & ", " & pkt(ii).y)
		Next
		gpx.LineTo(x0,y0)
		
		'Testzwecke:
'		gpx.Initialize(0,0)
'		gpx.LineTo(300dip,0)
'		gpx.LineTo(300dip,200dip)
'		gpx.LineTo(0,200dip)
'		gpx.LineTo(0,0)
		
		canv.Initialize(xview)	'resets die pan.backcolor auf 0
		canv.DrawPath(gpx,Colors.Black,True,0)
		'canv.DrawPathRotated(gpx,0,True,0,-45,x0,y0)
		'canv.DrawPath(gpx,Colors.Red,False,PenWid)
		If highlightBevelLower Then
			'Schleifflächen:
			canv.DrawLine(x0,y0,pkt(4).x,pkt(4).y,Colors.red,PenWid*2)
		End If
		If highlightBevelUpper And Not(onebevel) Then
			canv.DrawLine(x0,y0,pkt(1).x,pkt(1).y,Colors.red,PenWid*2)
		End If
		
		'Gelbe Linien+Winkel:
		If showHelpLines Then
			If onebevel Then
				rr=Max(2*HalbeDicke,0.9*GrindLen*CosD(grindAngle))
			Else
				rr=Max(HalbeDicke,0.9*GrindLen*CosD(grindAngle))
			End If
			rr=Min(rr,0.9*(panW-x0))
			Dim gpx2 As B4XPath		'für den Winkel
			If onebevel Then
				gpx2.InitializeArc(x0,y0,rr,0,grindAngle+0.5*grindAngle/90*dickenPlus)	'da die Methode einen Strich von x0,y0 zum start führt wird der Start nicht auf 0 verlegt
			Else
				gpx2.InitializeArc(x0,y0,rr,0,grindAngle)	'da die Methode einen Strich von x0,y0 zum start führt wird der Start nicht auf 0 verlegt
			End If
			canv.DrawLine(pkt(4).x,pkt(4).y,pkt(1).x,pkt(1).y,Colors.Yellow,PenWid)
			canv.DrawPath(gpx2,Colors.Yellow,False,PenWid)
			If onebevel=False Then	'zentrale Linie
				canv.DrawLine(x0,y0,x0+Sqrt(Power(GrindLen,2) -  Power(HalbeDicke , 2)),y0,Colors.Yellow,PenWid	)
			End If
		End If
	Else		'Winkel ist 0
		canv.DrawLine(x0,y0,panW,y0,Colors.Red,PenWid*2)
	End If
	
	
	'Text: Wird momentan nicht benutzt
	If False Then
		Dim fnt As B4XFont
		fnt=xui.CreateDefaultBoldFont(16)
		Dim tx As String
		tx="Grinding angle: " & grindAngle & "°, cutting angle: "
		If onebevel Then
			tx= tx & grindAngle & "°"
		Else
			tx=tx & (grindAngle*2) & "°"
		End If
		canv.DrawText(tx,10dip,y0+16dip,fnt,Colors.Yellow,"LEFT")
	End If
	
	canv.Invalidate
'	Dim bb =canv.CreateBitmap As Bitmap
'	Dim rc As Rect
'	rc.Initialize(0,0,100,100)
	Dim bmp As B4XBitmap=canv.CreateBitmap

	If flipHoriz Then
		bmp=BmEf.FlipHorizontal(bmp)
	End If
	
	Return bmp
End Sub

Private Sub   GeradenSchnittpunkt(G1 As Mypkt, G2 As Mypkt, H1 As Mypkt, H2 As Mypkt) As Mypkt
	'https://de.wikipedia.org/wiki/Geradengleichung#Haupt-_oder_Normalform
	Dim mg, tg, mh, th As Double
	Dim p As Mypkt
	p.Initialize

	If G2.x = G1.x And H2.x = H1.x Then 'Beide senkrecht
		p.isError = True
		Return p
	End If

	If G1.x = G2.x Then  'G ist Senkrecht
		mh = (H2.y - H1.y) / (H2.x - H1.x)
		th = (H1.y * H2.x - H2.y * H1.x) / (H2.x - H1.x)
		p.y = mh * G1.x + th
		p.x = G1.x
		Return p
	End If

	If H1.x = H2.x Then  'H senkrecht
		mg = (G2.y - G1.y) / (G2.x - G1.x)
		tg = (G1.y * G2.x - G2.y * G1.x) / (G2.x - G1.x)
		p.y = mg * H1.x + tg
		p.x = H1.x
		Return p
	End If

	mg = (G2.y - G1.y) / (G2.x - G1.x)
	mh = (H2.y - H1.y) / (H2.x - H1.x)
	If mg = mh Then   'Parallel
		p.isError = True
		Return p
	End If

	tg = (G1.y * G2.x - G2.y * G1.x) / (G2.x - G1.x)
	th = (H1.y * H2.x - H2.y * H1.x) / (H2.x - H1.x)
	p.x = (th - tg) / (mg - mh)
	p.y = mg * p.x + tg
	Return p
	

End Sub
   
private Sub Geradenschnittpunkt2( G1 As Mypkt, alpha As Float,H1 As Mypkt, H2 As Mypkt) As Mypkt
	'alpha in deg
	Dim p,G2 As Mypkt
	p.Initialize
	G2.Initialize
	G2.x=G1.x+100*CosD(alpha)
	G2.y=G1.y-100*SinD(alpha)
	p=GeradenSchnittpunkt(G1,G2,H1,H2)
	Return p
End Sub
